function [ output  ] = CMUSIC( SNR )
tic

% SNR=-10;  %% input SNR

M=60;
K=15;   %% number of users
Num_snapshot=20;
doa_separation=3;

DOA_start=-30;
N_Frame=200;  %% Monte-Carlo
search_step=0.5;   %deg

sigma_n=sqrt(M/10^(SNR/10));  %% square root of variance of noise
N_Sym=Num_snapshot;  %% Symbols

sita(1)=DOA_start;
delta=doa_separation;
for i=2:K
    sita(i)=sita(i-1)+delta;
end
sita=sita/180*pi;

A=ones(K,N_Frame);

resolve_num_CMUSIC=0;
error_CMUSIC=zeros(N_Frame,K);
Pi_M=fliplr(eye(M));

tao=0.7;

beta=3;
Omega=zeros(M,K);

for nframe=1:N_Frame
    b=sign(randn(K,N_Sym));
    noise=(sigma_n/sqrt(2))*(randn(M,N_Sym)+j*randn(M,N_Sym));
    ro=sign(randn(1,N_Sym));
    b(2,:)=tao*b(1,:)+sqrt(1-tao^2)*ro;
    b(15,:) = 2*b(15,:);
    b(14,:) = 4*b(14,:);
    
    %% generate steering vector and fading coefficients
    for k=1:K
        steering_matrix(:,k)=exp(-j*pi*[0:M-1]'*sin(sita(k)));
    end
    
    C_xx=zeros(M,M);
    for nsym=1:N_Sym
        for k=1:K       %% transmit data
            transmit_data(:,k)=abs(A(k,nframe))*steering_matrix(:,k)*b(k,nsym);
        end
        received_vec(:,nsym)=sum(transmit_data,2)+noise(:,nsym);  % desired_symbol=b(1,nsym);
        C_xx=C_xx+received_vec(:,nsym)*received_vec(:,nsym)';
    end
    C_xx=C_xx/N_Sym;
    
        %% test CMUSIC with FBA
              C_xx=1/2*(C_xx+Pi_M*conj(C_xx)*Pi_M);
    
    %% For CMUSIC algorihtm we compute the eigen decomposition
    [EigenVector, EigenValueMatrix]=eig(C_xx);
    EigenValue=diag(EigenValueMatrix)';
    [EigenValue,I]=sort(EigenValue);
    EigenValue=fliplr(EigenValue);
    EigenVector=fliplr(EigenVector(:,I));
    Noise_Subspace=EigenVector(:,(K+1):M);
    
    G1=Noise_Subspace;
    for kk=1:beta
        for mm=1:M
            Omega(mm,kk)=exp(-j*pi*(mm-1)*(kk-1)*2/beta);
        end
        for tt=1:M-K
            G_temp(:,tt)=conj([Omega(:,kk)]);
        end
        G(:,:,kk)=G_temp.*G1;
        P(:,:,kk)=G(:,:,kk)*G(:,:,kk)';
    end
    
    Q=beta*eye(M)-sum(P,3);
    [Pi, Om, EE ]=svd(Q);
    SingularValue=diag(Om)';
    [SingularValue,I]=sort(SingularValue);
    SingularValue=fliplr(SingularValue);
    Pi=fliplr(Pi(:,I));
    G_new=EE(:,(beta*K+1):M);
    
    phi_num=0;
    search_low=asin(1-2/beta);
    search_low=search_low*180/pi;
    search_high=90;
    for phi=search_low:search_step:search_high
        phi_num=phi_num+1;
        V_phi=exp(-j*pi*[0:M-1]'*sin(phi/180*pi));
        
        %% CMUSIC algorithm
        P_CMUSIC(nframe,phi_num)=1/(V_phi'*G_new*G_new'*V_phi);
    end
    phi=search_low:search_step:search_high;
    %         figure;
%         plot(phi,P_CMUSIC(nframe,:));
    %
    %% CMUSIC algorithm
    P_CMUSIC_nframe=real(P_CMUSIC(nframe,:));
    power_peak=0;
    index_l_hat=0;
    [power_peak,index_l_hat]=findpeaks(P_CMUSIC_nframe);
%     ss=1;
%     for ts=1:length(index_l_hat)
%         if power_peak(ts)>=0.025*max(power_peak)
%             power_peak_true(ss)=power_peak(ts);
%             index_true(ss)=index_l_hat(ts);
%             ss=ss+1;
%         end
%     end
    power_peak_true=power_peak;
    index_true=index_l_hat;
%     size(index_true)
    
    sita_peak=search_low+(index_true-1)*search_step;
    L_p=length(sita_peak); % L'
    
    sita_hat=zeros(L_p,beta);
    for kkk=1:beta
        sita_hat(:,kkk)=asin(sin(sita_peak/180*pi)-(kkk-1)*2/beta);% row number:L_p,column: beta
    end
    
    P_out_CMUSIC=zeros(1,L_p*beta);
    for ll=1:L_p  % row
        for kkkk=1:beta  %colomn
            a_sita_k=exp(-j*pi*[0:M-1]'*sin(sita_hat(ll,kkkk)));
            P_out_CMUSIC((ll-1)*beta+kkkk)=1/(a_sita_k'*G1*G1'*a_sita_k);
        end
    end
    
    [Max_K,Index]=sort(P_out_CMUSIC,'descend');
    
    Index_k_column=mod(Index(1:K),beta);
    for aa=1:length(Index_k_column)
        if Index_k_column(aa)==0
            Index_k_column(aa)=beta;
        end
    end
    
    Index_k_row=(Index(1:K)-Index_k_column(1:K))./beta+1;
    
%     m1=max(Index_k_column)
%     m2=max(Index_k_row)
    
    for kt=1:K
        sita_out(kt)=sita_hat(Index_k_row(kt),Index_k_column(kt));
    end
    %          sita_out=sita_out/pi*180;
    doa_est_temp_CMUSIC(nframe,:)=sort(sita_out);
    error_CMUSIC(nframe,:)=abs(doa_est_temp_CMUSIC(nframe,:)-sita);
    if max(error_CMUSIC(nframe,:))<delta*pi/360
        resolve_num_CMUSIC=resolve_num_CMUSIC+1;
    end
    rmse_temp_CMUSIC(nframe)=error_CMUSIC(nframe,:)*error_CMUSIC(nframe,:)';
    
    
end

Pro_Res_CMUSIC=resolve_num_CMUSIC/N_Frame;
rmse_CMUSIC=sqrt(sum(rmse_temp_CMUSIC)/(N_Frame*K));

output=[Pro_Res_CMUSIC, rmse_CMUSIC]

toc


end

