function [ output ] = Fun_CRB_sources( snr_in,tt )

tic
% snr_in=20;
M=60;  %% number of antennas
K=15;   %% number of users
Num_snapshot=20;
doa_separation=3;

DOA_start=60;
N_Frame=50;  %% Monte-Carlo

SNR=snr_in;  %% input SNR
sigma_n=sqrt(M/10^(SNR/10));  %% square root of variance of noise
N_Sym=Num_snapshot;  %% Symbols

sita(1)=DOA_start;
delta=doa_separation;
for i=2:K
    sita(i)=sita(i-1)+delta;
end
if tt==1
    sita(7) = sita(8)-1.5;
end
sita=sita/180*pi;

A=ones(K,N_Frame);
tao=0.7;
Pi_M=fliplr(eye(M));

for nframe=1:N_Frame
    b=sign(randn(K,N_Sym));
    noise=(sigma_n/sqrt(2))*(randn(M,N_Sym)+j*randn(M,N_Sym));
    ro=sign(randn(1,N_Sym));
    b(2,:)=tao*b(1,:)+sqrt(1-tao^2)*ro;
    b(15,:) = 2*b(15,:);
    b(14,:) = 4*b(14,:);
    
    %% generate steering vector and fading coefficients
     for k=1:K
         steering_matrix(:,k)=exp(-j*pi*[0:M-1]'*cos(sita(k)));
         D_steering_matrix(:,k)=([0:M-1]'*j).*steering_matrix(:,k);   % the CRB is for -pi*cos(sita(k))
         G_vector_inv(k)=1/pi/sin(sita(k));
     end
     
     Pi=eye(M,M)-steering_matrix*inv(steering_matrix'*steering_matrix)*steering_matrix';
     
     C_xx=zeros(M,M);
     for nsym=1:N_Sym
         for k=1:K       %% transmit data
             transmit_data(:,k)=abs(A(k,nframe))*steering_matrix(:,k)*b(k,nsym);
         end
         received_vec(:,nsym)=sum(transmit_data,2)+noise(:,nsym);  % desired_symbol=b(1,nsym);
         C_xx=C_xx+received_vec(:,nsym)*received_vec(:,nsym)';
         X_diag=diag(b(:,nsym));
         Re(:,:,nsym)=real((X_diag'*D_steering_matrix'*Pi*D_steering_matrix*X_diag));         
     end
         C_xx=C_xx/N_Sym;
         C_xx=1/2*(C_xx+Pi_M*conj(C_xx)*Pi_M);  % useless

         Sum_Re=sum(Re,3);
         CRB_phi_exact_matrix=sigma_n^2/2*inv(Sum_Re);
         
         Transfer_G_inv=diag(G_vector_inv);
         CRB_sita_exact_matrix=Transfer_G_inv*CRB_phi_exact_matrix*Transfer_G_inv;
         CRB_exact(nframe,:)=diag(CRB_sita_exact_matrix);

        %% for the approximate CRB         
         Re_appro=real((D_steering_matrix'*Pi*D_steering_matrix).*eye(K));
         CRB_phi_appro_matrix=sigma_n^2/(2*N_Sym)*inv(Re_appro);
         CRB_sita_appro_matrix=Transfer_G_inv*CRB_phi_appro_matrix*Transfer_G_inv;
         CRB_appro(nframe,:)=diag(CRB_sita_appro_matrix);                 
         
end

CRB_exact_out=sqrt(mean(mean(CRB_exact,1)));  %% in order to be consistant with the RMSE, take sqrt()
CRB_appro_out=sqrt(mean(mean(CRB_appro,1))); %% in order to be consistant with the RMSE, take sqrt()

output=[CRB_exact_out,CRB_appro_out]
toc

end

