function [ output ] = Fun_GLRD_sources( SNR,tt )
tic
% SNR=5;

D=5;

M=60;
K=15;

I=12;
search_step=0.5;
N_Frame=50;


Num_snapshot=20;
doa_separation=3;
DOA_start=60;

delta=1000;

sigma_n=sqrt(M/10^(SNR/10));  %% square root of variance of noise

N_Sym=Num_snapshot;  %% Symbols

sita  = linspace(DOA_start,DOA_start+(K-1)*doa_separation,K);
if tt==1
    sita(7) = sita(8)-1.5;
end
sita=sita/180*pi;

FF=0.998;  % FF denotes the forgetting factor
T_D=zeros(M,D);
error_GLRD=zeros(N_Frame,K);
P_db=zeros(I,I,D);
P_jb=zeros(I,D,D);
s_db=zeros(I,D);

resolve_num_GLRD=0;

for dd=1:D
    mu(dd)=(dd-1)*floor(M/D);
end

% tao12=(sqrt(2)+sqrt(2)*j)/2;
% tao13=(sqrt(3)+sqrt(3)*j)/2;
tao12= 0.7;

QQ = eye(D);
for nframe=1:N_Frame
    b=sign(randn(K,N_Sym));
    noise=(sigma_n/sqrt(2))*(randn(M,N_Sym)+j*randn(M,N_Sym));
    ro=sign(randn(1,N_Sym));
    b(2,:)=tao12*b(1,:)+sqrt(1-tao12^2)*ro;
    b(14,:)=2* b(14,:);
    b(15,:) = 4* b(15,:);
    
    for k=1:K
        steering_matrix(:,k)=exp(-j*pi*[0:M-1]'*cos(sita(k)));
    end
     
     for nsym=1:N_Sym
         for k=1:K       %% transmit data
             transmit_data(:,k)=steering_matrix(:,k)*b(k,nsym);
         end
         received_vec(:,nsym)=sum(transmit_data,2)+noise(:,nsym);  % desired_symbol=b(1,nsym);
         
         R_cor(:,:,nsym) = received_vec(:,nsym)*received_vec(:,nsym)';
     end
                 
    phi_num=0;
    for phi=0:search_step:180
        phi_num=phi_num+1;
        V_phi=exp(-j*pi*[0:M-1]'*cos(phi/180*pi));
        V_phi_aug = [V_phi; zeros(I-1,1)];
                
        %% initializations
        w=0.01*ones(D,1);
        P_D=(1/delta)*eye(D,D);         
        for dd=1:D
            P_db(:,:,dd)=(1/delta)*eye(I,I);  % this stands for Pdb(0)
            for ff=1:D
                P_jb(:,ff,dd)=0.01*ones(I,1);  % this stands for Pjb(0)
            end
            s_db(:,dd)=0.01*ones(I,1);
            s_db_temp(:,dd)=s_db(:,dd);
        end
        
        for nsym=1:N_Sym
            
            s_db_temp=s_db;

            r_D = zeros(D,1);
            V_phi_D = zeros(D,1);
            
            rec_aug = [received_vec(:,nsym); zeros(I-1,1)];
            
            for dd=1:D
                Xdb=rec_aug((mu(dd)+1):(mu(dd)+I));
%                 Xdb = Hankel_rec(mu(dd)+1,:).';
                pai=P_db(:,:,dd)*Xdb;
                FF1=w(dd)*conj(w(dd));FF1=FF1^(-1);
                gain=pai./(FF*FF1+Xdb'*pai);
                Prime=gain*Xdb'*P_db(:,:,dd);
                P_db(:,:,dd)=(P_db(:,:,dd)-Prime)./FF;
                
                Sum2=zeros(I,1);
                T=0;
                for jj=1:D
                    An = V_phi_aug((mu(jj)+1):(mu(jj)+I));
%                     An = Hankel_An(mu(jj)+1,:).';
                    if jj~=dd
                        Xjb = rec_aug((mu(jj)+1):(mu(jj)+I));
%                         Xjb = Hankel_rec(mu(jj)+1,:).';
                        P_jb(:,jj,dd)=FF*P_jb(:,jj,dd)+Xdb*conj(w(dd))*w(jj)*Xjb'*s_db_temp(:,jj);
                        Sum2=Sum2+P_jb(:,jj,dd);
                        T=T+w(jj)*An'*s_db_temp(:,jj);
                    end
                end
                An=V_phi_aug((mu(dd)+1):(mu(dd)+I));
%                 An = Hankel_An(mu(dd)+1,:).';                
                C=P_db(:,:,dd)*conj(w(dd))*An;
                B1=P_db(:,:,dd)*Sum2;
                alpha=(T-1-w(dd)*An'*B1)/(w(dd)*An'*C);
                s_db(:,dd)=-P_db(:,:,dd)*Sum2-alpha.*P_db(:,:,dd)*An*conj(w(dd));
%                 for ff=1:D
%                     if ff~=dd
%                        T_D(:,ff)=[zeros(mu(ff),1);s_db_temp(:,ff);zeros((M-mu(ff)-I),1)];
%                     else
%                        T_D(:,ff)=[zeros(mu(ff),1);s_db(:,ff);zeros((M-mu(ff)-I),1)];
%                     end
%                 end
%                 w'*T_D'*V_phi
               %% q_d,d_db
               r_D = r_D + QQ(:,dd) * Xdb.' * conj(s_db(:,dd));
               V_phi_D = V_phi_D + QQ(:,dd) * An.' * conj(s_db(:,dd));
            end

            %% compute the output power in each branch
%             for dd=1:D
%                 T_D(:,dd)=[zeros(mu(dd),1);s_db(:,dd);zeros((M-mu(dd)-I),1)];
%             end   
%             %% next we update w(i)
%             V_phi=exp(-j*pi*[0:M-1]'*cos(phi/180*pi));
%             r_D1=T_D'*received_vec(:,nsym)
%             V_phi_D=T_D'*V_phi;
%             k_D=P_D*r_D/(FF+r_D'*P_D*r_D);
%             P_D=FF^(-1)*P_D-FF^(-1)*k_D*r_D'*P_D;
%             w=P_D*V_phi_D/(V_phi_D'*P_D*V_phi_D);

            %% next we update w(i)
            k_D=P_D*r_D/(FF+r_D'*P_D*r_D);
            P_D=FF^(-1)*P_D-FF^(-1)*k_D*r_D'*P_D;
            w=P_D*V_phi_D/(V_phi_D'*P_D*V_phi_D);
        end
       %% compute the output power
        P_GLRD(nframe,phi_num)=1/(V_phi_D'*P_D*V_phi_D);
        
    end
    
    phi=0:search_step:180;
    
%     figure;
%     plot(phi,P_GLRD(nframe,:));
    
    P_GLRD_nframe=real(P_GLRD(nframe,:));
    t_GLRD=find(diff(sign(diff(P_GLRD_nframe)))==-2)+1;
    P_GLRD_localmaxs=P_GLRD_nframe(t_GLRD);
    P_GLRD_localmaxs_sorted=sort(P_GLRD_localmaxs);
    localmax_number_GLRD=length(P_GLRD_localmaxs_sorted);
    
    if localmax_number_GLRD>=K
        for i=1:K
            doa_index(i)=find(P_GLRD_nframe==P_GLRD_localmaxs_sorted(localmax_number_GLRD-i+1));
        end
    else
        for i=1:length(localmax_number_GLRD)
            doa_index(i)=find(P_GLRD_nframe==P_GLRD_localmaxs_sorted(localmax_number_GLRD-i+1));
        end
        for i=length(localmax_number_GLRD)+1:K
            doa_index(i)=find(P_GLRD_nframe==P_GLRD_localmaxs_sorted(1));
        end
    end
    
%          output_Power=P_GLRD(nframe,:);
% %          figure;
%          phi_test=0:search_step:180;
%          plot(phi_test,output_Power);
         
    doa_est_deg(nframe,:)=sort(phi(doa_index));
    doa_est(nframe,:)=doa_est_deg(nframe,:)./180.*pi; % rad
    error_GLRD(nframe,:)=abs(doa_est(nframe,:)-sita);
  
    error_def(nframe,:) = doa_est(nframe,:)-sita;

    max_error_GLRD(nframe)=max(error_GLRD(nframe,:));
    if max_error_GLRD(nframe)<doa_separation*pi/360
        resolve_num_GLRD=resolve_num_GLRD+1;
    end
    %% RMSE
    rmse_GLRD(nframe)=error_GLRD(nframe,:)*error_GLRD(nframe,:)';
    
end

Pro_Res_GLRD=resolve_num_GLRD/N_Frame;
rmse_GLRD=sqrt(sum(rmse_GLRD)/(N_Frame*K));

ave_nframe = sum(error_def,1)/N_Frame;
ave = mean(ave_nframe)*180/pi

output=[Pro_Res_GLRD,rmse_GLRD,ave]

toc

% end