function [ output ] = Fun_JIDF_sources( snr_in, tt )
tic
% snr_in=20;
M=60;  %% number of antennas
K=15;   %% number of users
Num_snapshot=20;
doa_separation=3;

DOA_start=60;
N_Frame=100;  %% Monte-Carlo
search_step=0.5;

SNR=snr_in;  %% input SNR
sigma_n=sqrt(M/10^(SNR/10));  %% square root of variance of noise

N_Sym=Num_snapshot;  %% Symbols

sita(1)=DOA_start;
delta=doa_separation;
for i=2:K
    sita(i)=sita(i-1)+delta;
end
if tt==1
   sita(7) = sita(8)-1.5;
end
sita=sita/180*pi;

A=ones(K,N_Frame);
rmse_temp_JIDF=zeros(1,N_Frame);

%% Initialization for JIDF
rank_i=12;  % dimension of Vec_v
rank_d=10;   %  reduced rank
forgetting_factor_JIDF=0.998;      
delta_ini=0.001;
B=1;

%% generate the decimation matrix Tb for each branch
for num_branch=1:B
    for rr=1:rank_d  %decimation matrix dimension: rank_r*M
        phi_vec_rr_b=zeros(M,1);
        nonzero_index=floor(M/rank_d)*(rr-1)+(num_branch-1)+1;
        phi_vec_rr_b(nonzero_index)=1;
        decimation_T(rr,:,num_branch)=phi_vec_rr_b';
    end
end

resolve_num_JIDF=0;
error_JIDF_branch=zeros(B,K);

tao12 = 0.7;

for nframe=1:N_Frame
    b=sign(randn(K,N_Sym));
    noise=(sigma_n/sqrt(2))*(randn(M,N_Sym)+j*randn(M,N_Sym));
    ro=sign(randn(1,N_Sym));
    b(2,:)=tao12*b(1,:)+sqrt(1-tao12^2)*ro;
    b(15,:) = 2*b(15,:);
    b(14,:) = 4*b(14,:);
    
    %% generate steering vector and fading coefficients
     for k=1:K
         steering_matrix(:,k)=exp(-j*pi*[0:M-1]'*cos(sita(k)));
     end
     
     C_xx=zeros(M,M);
     for nsym=1:N_Sym
         for k=1:K       %% transmit data
             transmit_data(:,k)=abs(A(k,nframe))*steering_matrix(:,k)*b(k,nsym);
         end
         received_vec(:,nsym)=sum(transmit_data,2)+noise(:,nsym);  % desired_symbol=b(1,nsym);
         C_xx=C_xx+received_vec(:,nsym)*received_vec(:,nsym)';
     end
        
         C_xx=C_xx/N_Sym;
                  
     phi_num=0;
     for phi=0:search_step:180
         phi_num=phi_num+1;
         V_phi=exp(-j*pi*[0:M-1]'*cos(phi/180*pi));
                  
         %% JIDF multi-branch
         for num_branch=1:B
           %% generate Tb
             first_column=V_phi;
             last_row=zeros(rank_i,1);last_row(1)=V_phi(M);
             So_phi_Hankel=hankel(first_column,last_row);         %% So
             decimation_T_b=decimation_T(:,:,num_branch);
           %% initialization             
             P_v_b=delta_ini*eye(rank_i,rank_i);
             P_w_b=delta_ini*eye(rank_d,rank_d);
             w_b=zeros(rank_d,1);w_b(1)=0.8;
             v_b=zeros(rank_i,1);v_b(1)=0.8;  % maybe useless
             s_v_b=conj(So_phi_Hankel')*conj(decimation_T_b')*conj(w_b);
             s_w_b=decimation_T_b*So_phi_Hankel*conj(v_b);  % maybe useless
               %% symbol filtering
             for nsym=1:N_Sym
              %% generate the hankel matrix of received_vec
                first_column_Ro=received_vec(:,nsym);
                last_row_Ro=zeros(rank_i,1);last_row_Ro(1)=received_vec(M,nsym);
                Ro_received_vec_hankel=hankel(first_column_Ro,last_row_Ro);   %% dimension: M*I             
              %%  step1: updating v_b
                r_v_b=conj(Ro_received_vec_hankel')*conj(decimation_T_b')*conj(w_b);
                k_v_b=P_v_b*r_v_b/(forgetting_factor_JIDF+r_v_b'*P_v_b*r_v_b);
                P_v_b=forgetting_factor_JIDF^(-1)*P_v_b-forgetting_factor_JIDF^(-1)*k_v_b*r_v_b'*P_v_b;
                v_b=P_v_b*s_v_b/(s_v_b'*P_v_b*s_v_b);
                s_w_b=decimation_T_b*So_phi_Hankel*conj(v_b);
              %% step2: updating w_b
                r_w_b=decimation_T_b*Ro_received_vec_hankel*conj(v_b);
                k_w_b=P_w_b*r_w_b/(forgetting_factor_JIDF+r_w_b'*P_w_b*r_w_b);
                P_w_b=forgetting_factor_JIDF^(-1)*P_w_b-forgetting_factor_JIDF^(-1)*k_w_b*r_w_b'*P_w_b;
                w_b=P_w_b*s_w_b/(s_w_b'*P_w_b*s_w_b);
                s_v_b=conj(So_phi_Hankel')*conj(decimation_T_b')*conj(w_b);
             end
             P_JIDF_RLS_temp(nframe,phi_num,num_branch)=1/(s_w_b'*P_w_b*s_w_b);       
         end       
     end 
         phi=0:search_step:180;

        %% JIDF multi-branch         
         for num_branch=1:B
             P_JIDF_RLS_nframe_branch=real(P_JIDF_RLS_temp(nframe,:,num_branch)); % phi_num
             t_JIDF=find(diff(sign(diff(P_JIDF_RLS_nframe_branch)))==-2)+1;
             P_JIDF_RLS_localmaxs=P_JIDF_RLS_nframe_branch(t_JIDF);
             P_JIDF_RLS_localmaxs_sorted=sort(P_JIDF_RLS_localmaxs);
             localmax_number_JIDF=length(P_JIDF_RLS_localmaxs_sorted);
           %% JIDF
            if localmax_number_JIDF>=K
               for i=1:K
                   doa_index(i)=find(P_JIDF_RLS_nframe_branch==P_JIDF_RLS_localmaxs_sorted(localmax_number_JIDF-i+1));
               end
            else
               for i=1:length(localmax_number_JIDF)
                   doa_index(i)=find(P_JIDF_RLS_nframe_branch==P_JIDF_RLS_localmaxs_sorted(localmax_number_JIDF-i+1));                   
               end
               for i=length(localmax_number_JIDF)+1:K
                   doa_index(i)=find(P_JIDF_RLS_nframe_branch==P_JIDF_RLS_localmaxs_sorted(1));
               end
            end
            doa_est_temp=sort(phi(doa_index)/180*pi);  % rad 
            error_JIDF_branch(num_branch,:)=abs(doa_est_temp-sita);
            max_element_error(num_branch)=max(error_JIDF_branch(num_branch,:));
         end 
         %% choose branch
         branch_selected=find(max_element_error==min(max_element_error));
         if length(branch_selected)~=1
            branch_selected_final=branch_selected(1);
         else
            branch_selected_final=branch_selected;
         end
         
         %% test the power spectrum
         P_JIDF_RLS_nframe_branch_selected_final=real(P_JIDF_RLS_temp(nframe,:,branch_selected_final));
%          figure;
%          plot(phi,P_JIDF_RLS_nframe_branch_selected_final);
         
         
         error_JIDF_multibranch(nframe)=min(max_element_error);
         if error_JIDF_multibranch(nframe)<delta*pi/360
            resolve_num_JIDF=resolve_num_JIDF+1;
         end
         error_branch_selected=error_JIDF_branch(branch_selected_final,:);
         %% RMSE
         rmse_temp_JIDF(nframe)=error_branch_selected*error_branch_selected';
         
end

Pro_Res_JIDF=resolve_num_JIDF/N_Frame;
rmse_JIDF=sqrt(sum(rmse_temp_JIDF)/(N_Frame*K));

output=[Pro_Res_JIDF,rmse_JIDF]

toc

end

