function [ output ] = Fun_JIO_sources( snr_in,tt )
tic
% snr_in=0;
M=60;  %% number of antennas
K=15;   %% number of users
Num_snapshot=20;
doa_separation=3;

DOA_start=60;
search_step=0.5;
N_Frame=50;  %% Monte-Carlo

SNR=snr_in;  %% input SNR
sigma_n=sqrt(M/10^(SNR/10));  %% square root of variance of noise
N_Sym=Num_snapshot;  %% Symbols

sita=zeros(1,K);
sita(1)=DOA_start;
delta=doa_separation;
for i=2:K
    sita(i)=sita(i-1)+delta;
end
if tt==1
    sita(7)= sita(8)-1.5;
end
sita=sita/180*pi;

A=ones(K,N_Frame);
resolve_num_JIO=0;
error_JIO=zeros(N_Frame,K);

%% Initialization for JIO
r=5;   %  reduced rank
delta_ini_JIO=0.001;
delta_bar=0.001;
forgetting_factor_JIO=0.998;

tao12=0.7;

for nframe=1:N_Frame
    b=sign(randn(K,N_Sym));
    noise=(sigma_n/sqrt(2))*(randn(M,N_Sym)+j*randn(M,N_Sym));
    ro=sign(randn(1,N_Sym));
    b(2,:)=tao12*b(1,:)+sqrt(1-tao12^2)*ro;
    b(15,:) = 2*b(15,:);
    b(14,:) = 4*b(14,:);
    
    %% generate steering vector and fading coefficients
     for k=1:K
         steering_matrix(:,k)=exp(-j*pi*[0:M-1]'*cos(sita(k)));
     end
     
     C_xx=zeros(M,M);
     for nsym=1:N_Sym
         for k=1:K       %% transmit data
             transmit_data(:,k)=abs(A(k,nframe))*steering_matrix(:,k)*b(k,nsym);
         end
         received_vec(:,nsym)=sum(transmit_data,2)+noise(:,nsym);  % desired_symbol=b(1,nsym);
         C_xx=C_xx+received_vec(:,nsym)*received_vec(:,nsym)';
     end
        
         C_xx=C_xx/N_Sym;
         
     phi_num=0;
     for phi=0:search_step:180   % deg
         phi_num=phi_num+1;
         V_phi=exp(-j*pi*[0:M-1]'*cos(phi/180*pi));
         
        %% JIO algorithm
         G_bar=zeros(r,1);G_bar(1)=0.1;
         Phi=delta_ini_JIO*eye(M,M);
         Phi_bar=delta_bar*eye(r,r);       
        %% JIO symbol filtering
         for nsym=1:N_Sym
             K_gain=Phi*received_vec(:,nsym)/(forgetting_factor_JIO+received_vec(:,nsym)'*Phi*received_vec(:,nsym));
             Phi=forgetting_factor_JIO^(-1)*Phi-forgetting_factor_JIO^(-1)*K_gain*received_vec(:,nsym)'*Phi;
             Tr=(Phi*V_phi/(V_phi'*Phi*V_phi))*(G_bar'/(G_bar'*G_bar));
             
             received_vec_bar=Tr'*received_vec(:,nsym);
             V_phi_bar=Tr'*V_phi;
             K_gain_bar=Phi_bar*received_vec_bar/(forgetting_factor_JIO+received_vec_bar'*Phi_bar*received_vec_bar);
             Phi_bar=forgetting_factor_JIO^(-1)*Phi_bar-forgetting_factor_JIO^(-1)*K_gain_bar*received_vec_bar'*Phi_bar+0.0001*eye(r);            
             G_bar=Phi_bar*V_phi_bar/(V_phi_bar'*Phi_bar*V_phi_bar);
         end
         P_JIO_RLS(nframe,phi_num)=1/(V_phi_bar'*Phi_bar*V_phi_bar);
         
     end 
         phi=0:search_step:180;
     
%      figure;
%      plot(phi,real(P_JIO_RLS(nframe,:)));

        %% JIO algorithm
         P_JIO_RLS_nframe=real(P_JIO_RLS(nframe,:));
         t_JIO=find(diff(sign(diff(P_JIO_RLS_nframe)))==-2)+1;
         P_JIO_RLS_localmaxs=P_JIO_RLS_nframe(t_JIO);
         P_JIO_RLS_localmaxs_sorted=sort(P_JIO_RLS_localmaxs);
         localmax_number_JIO=length(P_JIO_RLS_localmaxs_sorted);
         
            %% JIO
            if localmax_number_JIO>=K
               for i=1:K
                   doa_index_JIO(i)=find(P_JIO_RLS_nframe==P_JIO_RLS_localmaxs_sorted(localmax_number_JIO-i+1));
               end
            else
               for i=1:length(localmax_number_JIO)
                   doa_index_JIO(i)=find(P_JIO_RLS_nframe==P_JIO_RLS_localmaxs_sorted(localmax_number_JIO-i+1));
               end
               for i=length(localmax_number_JIO)+1:K
                   doa_index_JIO(i)=find(P_JIO_RLS_nframe==P_JIO_RLS_localmaxs_sorted(1));
               end
            end
            doa_est_temp_JIO(nframe,:)=sort(phi(doa_index_JIO)/180*pi);
            error_JIO(nframe,:)=abs(doa_est_temp_JIO(nframe,:)-sita);
            if max(error_JIO(nframe,:))<delta*pi/360
               resolve_num_JIO=resolve_num_JIO+1;
            end
            rmse_temp_JIO(nframe)=error_JIO(nframe,:)*error_JIO(nframe,:)';
         
end


Pro_Res_JIO=resolve_num_JIO/N_Frame;
rmse_JIO=sqrt(sum(rmse_temp_JIO)/(N_Frame*K));

output=[Pro_Res_JIO, rmse_JIO]

toc

end

