function [ output  ] = QMethod1( SNR )
tic

% SNR=20;  %% input SNR

M=60;
K=15;   %% number of users
Num_snapshot=20;
doa_separation=3;

DOA_start=60;
N_Frame=1000;  %% Monte-Carlo
search_step=0.5;   %deg

sigma_n=sqrt(M/10^(SNR/10));  %% square root of variance of noise
N_Sym=Num_snapshot;  %% Symbols

sita(1)=DOA_start;
delta=doa_separation;
for i=2:K
    sita(i)=sita(i-1)+delta;
end
sita=sita/180*pi;

A=ones(K,N_Frame);

resolve_num_QMethod=0;
error_QMethod=zeros(N_Frame,K);

tao=0.7;


s=zeros(K,N_Sym);
t=zeros(M-K,N_Sym);

for nframe=1:N_Frame
    b=sign(randn(K,N_Sym));
    noise=(sigma_n/sqrt(2))*(randn(M,N_Sym)+j*randn(M,N_Sym));
    ro=sign(randn(1,N_Sym));
    b(2,:)=tao*b(1,:)+sqrt(1-tao^2)*ro;
    b(15,:) = 2*b(15,:);
    b(14,:) = 4*b(14,:);

    %% generate steering vector and fading coefficients
     for k=1:K
         steering_matrix(:,k)=exp(-j*pi*[0:M-1]'*cos(sita(k)));
     end
     
     phi=zeros(M,1);
     phi_bar=zeros(M,1);
     for nsym=1:N_Sym
         for k=1:K       %% transmit data
             transmit_data(:,k)=abs(A(k,nframe))*steering_matrix(:,k)*b(k,nsym);
         end
         received_vec(:,nsym)=sum(transmit_data,2)+noise(:,nsym);  % desired_symbol=b(1,nsym);
         s(:,nsym)=received_vec(1:K,nsym);
         t(:,nsym)=received_vec(K+1:M,nsym);
         
         if nsym==1
            G(:,:,nsym)=received_vec(:,nsym)*s(:,nsym)';
            H(:,:,nsym)=received_vec(:,nsym)*t(:,nsym)';
         else
%             G(:,:,nsym)=received_vec(:,nsym)*s(:,nsym)';
%             H(:,:,nsym)=received_vec(:,nsym)*t(:,nsym)';
                 
            G(:,:,nsym)=(1/nsym)*((nsym-1)*G(:,:,nsym-1)+received_vec(:,nsym)*s(:,nsym)');
            H(:,:,nsym)=(1/nsym)*((nsym-1)*H(:,:,nsym-1)+received_vec(:,nsym)*t(:,nsym)');                
% 
%             G(:,:,nsym)=lambda*G(:,:,nsym-1)+received_vec(:,nsym)*s(:,nsym)';
%             H(:,:,nsym)=lambda*H(:,:,nsym-1)+received_vec(:,nsym)*t(:,nsym)';             
            
         end
     end
     
     P=inv(G(:,:,N_Sym)'*G(:,:,N_Sym))*G(:,:,N_Sym)'*H(:,:,N_Sym);
     
     Q=[P;-eye(M-K)];
     
%     %% test QMethod with FBA
%           C_xx=1/2*(C_xx+Pi_M*conj(C_xx)*Pi_M);
     
     phi_num=0;
     for phi_search=0:search_step:180
         phi_num=phi_num+1;
         V_phi=exp(-j*pi*[0:M-1]'*cos(phi_search/180*pi));
                  
        %% QMethod algorithm
         P_QMethod(nframe,phi_num)=1/(V_phi'*Q*Q'*V_phi);
     end 
         phi_search=0:search_step:180;
%          figure;
%          plot(phi_search,P_QMethod(nframe,:));
         
        %% QMethod algorithm
         P_QMethod_nframe=real(P_QMethod(nframe,:));
         t_QMethod=find(diff(sign(diff(P_QMethod_nframe)))==-2)+1;
         P_QMethod_localmaxs=P_QMethod_nframe(t_QMethod);
         P_QMethod_localmaxs_sorted=sort(P_QMethod_localmaxs);
         localmax_number_QMethod=length(P_QMethod_localmaxs_sorted);
      
            %% QMethod
            if localmax_number_QMethod>=K
               for i=1:K
                  doa_index_QMethod(i)=find(P_QMethod_nframe==P_QMethod_localmaxs_sorted(localmax_number_QMethod-i+1));
               end
            else
               for i=1:length(localmax_number_QMethod)
                  doa_index_QMethod(i)=find(P_QMethod_nframe==P_QMethod_localmaxs_sorted(localmax_number_QMethod-i+1));
               end
               for i=length(localmax_number_QMethod)+1:K
                   doa_index_QMethod(i)=find(P_QMethod_nframe==P_QMethod_localmaxs_sorted(1));                  
               end
            end
            doa_est_temp_QMethod(nframe,:)=sort(phi_search(doa_index_QMethod)/180*pi);
            error_QMethod(nframe,:)=abs(doa_est_temp_QMethod(nframe,:)-sita);
            if max(error_QMethod(nframe,:))<delta*pi/360
               resolve_num_QMethod=resolve_num_QMethod+1;
            end
            rmse_temp_QMethod(nframe)=error_QMethod(nframe,:)*error_QMethod(nframe,:)';
                     
end

Pro_Res_QMethod=resolve_num_QMethod/N_Frame;
rmse_QMethod=sqrt(sum(rmse_temp_QMethod)/(N_Frame*K));

output=[Pro_Res_QMethod, rmse_QMethod]

toc


end

