function [ output  ] = SUMWE( SNR )
tic

% SNR=20;  %% input SNR

M=60;
K=15;   %% number of users
Num_snapshot=20;
doa_separation=5;

DOA_start=60;
N_Frame=500;  %% Monte-Carlo
search_step=0.5;   %deg

sigma_n=sqrt(M/10^(SNR/10));  %% square root of variance of noise
N_Sym=Num_snapshot;  %% Symbols

sita(1)=DOA_start;
delta=doa_separation;
for i=2:K
    sita(i)=sita(i-1)+delta;
end
sita=sita/180*pi;

A=ones(K,N_Frame);

resolve_num_SUMWE=0;
error_SUMWE=zeros(N_Frame,K);
Pi_M=fliplr(eye(M));

tao=0.7;

L=M-K+1;

for nframe=1:N_Frame
    b=sign(randn(K,N_Sym));
    noise=(sigma_n/sqrt(2))*(randn(M,N_Sym)+j*randn(M,N_Sym));
    ro=sign(randn(1,N_Sym));
    b(2,:)=tao*b(1,:)+sqrt(1-tao^2)*ro;
    b(15,:) = 2*b(15,:);
    b(14,:) = 4*b(14,:);

    %% generate steering vector and fading coefficients
     for k=1:K
         steering_matrix(:,k)=exp(-j*pi*[0:M-1]'*cos(sita(k)));
     end
     
     phi=zeros(M,1);
     phi_bar=zeros(M,1);
     for nsym=1:N_Sym
         for k=1:K       %% transmit data
             transmit_data(:,k)=abs(A(k,nframe))*steering_matrix(:,k)*b(k,nsym);
         end
         received_vec(:,nsym)=sum(transmit_data,2)+noise(:,nsym);  % desired_symbol=b(1,nsym);
         phi=phi+received_vec(:,nsym)*conj(received_vec(M,nsym));
         phi_bar=phi_bar+received_vec(:,nsym)*conj(received_vec(1,nsym));
     end
         phi=phi/N_Sym;
         phi_bar=phi_bar/N_Sym;
%     %% test SUMWE with FBA
%           C_xx=1/2*(C_xx+Pi_M*conj(C_xx)*Pi_M);

     %% For SUMWE algorihtm we :
     c1=phi(1:L-1);
     r1=phi(L-1:M-1).';
     Phi_f=hankel(c1,r1);
     Phi_f1=Phi_f(1:K,:);
     Phi_f2=Phi_f(K+1:end,:);
     
     c2=phi_bar(2:L);
     r2=phi_bar(L:M).';
     Phi_bar_f=hankel(c2,r2);
     Phi_bar_f1=Phi_bar_f(1:K,:);
     Phi_bar_f2=Phi_bar_f(K+1:end,:);
     
     c3=conj(phi_bar(M:-1:K+1));
     r3=phi_bar(K+1:-1:2)';
     Phi_b=hankel(c3,r3);
     Phi_b1=Phi_b(1:K,:);
     Phi_b2=Phi_b(K+1:end,:);
     
     c4=conj(phi(M-1:-1:K));
     r4=phi(K:-1:1)';
     Phi_bar_b=hankel(c4,r4);
     Phi_bar_b1=Phi_bar_b(1:K,:);
     Phi_bar_b2=Phi_bar_b(K+1:end,:);     
     
     Phi1=[Phi_f1,Phi_bar_f1,Phi_b1,Phi_bar_b1];
     Phi2=[Phi_f2,Phi_bar_f2,Phi_b2,Phi_bar_b2];
     
     
     P=inv(Phi1*Phi1')*Phi1*Phi2';
     Q=[P;-eye(M-2*K)];
     Pi_Q=Q*(eye(M-2*K)-P'*inv(P*P'+eye(K))*P)*Q';
     
              
     phi_num=0;
     for phi_search=0:search_step:180
         phi_num=phi_num+1;
         V_phi=exp(-j*pi*[0:M-1]'*cos(phi_search/180*pi));
         V_phi_bar=V_phi(1:L-1);
                  
        %% SUMWE algorithm
         P_SUMWE(nframe,phi_num)=1/(V_phi_bar'*Pi_Q*V_phi_bar);
     end 
         phi_search=0:search_step:180;
%          figure;
%          plot(phi_search,P_SUMWE(nframe,:));
         
        %% SUMWE algorithm
         P_SUMWE_nframe=real(P_SUMWE(nframe,:));
         t_SUMWE=find(diff(sign(diff(P_SUMWE_nframe)))==-2)+1;
         P_SUMWE_localmaxs=P_SUMWE_nframe(t_SUMWE);
         P_SUMWE_localmaxs_sorted=sort(P_SUMWE_localmaxs);
         localmax_number_SUMWE=length(P_SUMWE_localmaxs_sorted);
      
            %% SUMWE
            if localmax_number_SUMWE>=K
               for i=1:K
                  doa_index_SUMWE(i)=find(P_SUMWE_nframe==P_SUMWE_localmaxs_sorted(localmax_number_SUMWE-i+1));
               end
            else
               for i=1:length(localmax_number_SUMWE)
                  doa_index_SUMWE(i)=find(P_SUMWE_nframe==P_SUMWE_localmaxs_sorted(localmax_number_SUMWE-i+1));
               end
               for i=length(localmax_number_SUMWE)+1:K
                   doa_index_SUMWE(i)=find(P_SUMWE_nframe==P_SUMWE_localmaxs_sorted(1));                  
               end
            end
            doa_est_temp_SUMWE(nframe,:)=sort(phi_search(doa_index_SUMWE)/180*pi);
            error_SUMWE(nframe,:)=abs(doa_est_temp_SUMWE(nframe,:)-sita);
            if max(error_SUMWE(nframe,:))<delta*pi/360
               resolve_num_SUMWE=resolve_num_SUMWE+1;
            end
            rmse_temp_SUMWE(nframe)=error_SUMWE(nframe,:)*error_SUMWE(nframe,:)';
                     
end

Pro_Res_SUMWE=resolve_num_SUMWE/N_Frame;
rmse_SUMWE=sqrt(sum(rmse_temp_SUMWE)/(N_Frame*K));

output=[Pro_Res_SUMWE, rmse_SUMWE]

toc


end

